package com.zksy.web.controller.basicData;

import com.zksy.common.core.controller.BaseController;
import com.zksy.common.core.domain.AjaxResult;
import com.zksy.common.utils.file.ExcelUtils;
import com.zksy.system.basicData.domain.CrmBusinessAbnormality;
import com.zksy.system.basicData.service.CrmBusinessAbnormalityService;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zksy.utils.DowntemplateUtil;
import com.zksy.utils.SearchUtil;
import com.zksy.common.annotation.Log;
import com.zksy.common.enums.BusinessType;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

/**
 * 市场监管-经营异常Controller
 *
 * @author sy
 * @date 2024-06-03
 */
@RestController
@RequestMapping("/crmBusinessAbnormality")
@Api(tags = "市场监管-经营异常", description = "市场监管-经营异常desc")
public class CrmBusinessAbnormalityController extends BaseController{

    @Autowired
    private CrmBusinessAbnormalityService service;

    @GetMapping("/getById/{borrowId}")
    @ApiOperation(value = "市场监管-经营异常搜索getById")
    public CrmBusinessAbnormality getById(@PathVariable String borrowId) {
        return service.getById(borrowId);
    }

    @GetMapping("/findByPage")
    @ApiOperation(value = "市场监管-经营异常分页")
    public Page findByPage(long pageNum, long pageSize, String conditionJson) throws Exception {
        return service.page(new Page<>(pageNum, pageSize), SearchUtil.parseWhereSql(conditionJson));
    }

    @GetMapping("/getList")
    @ApiOperation(value = "市场监管-经营异常查询所有")
    public List<CrmBusinessAbnormality> getList(String conditionJson) throws Exception {
        return service.list(SearchUtil.parseWhereSql(conditionJson));
    }

    /**
     * 新增市场监管-经营异常
     */
    @PostMapping("/save")
    @ApiOperation(value = "市场监管-经营异常新增")
    @Log(title = "新增市场监管-经营异常", businessType = BusinessType.INSERT)
    public boolean save(@RequestBody CrmBusinessAbnormality crmBusinessAbnormality) {
        return service.save(crmBusinessAbnormality);
    }

    /**
     * 修改市场监管-经营异常
     */
    @PostMapping("/updateById")
    @ApiOperation(value = "市场监管-经营异常修改")
    @Log(title = "修改市场监管-经营异常", businessType = BusinessType.UPDATE)
    public boolean updateById(@RequestBody CrmBusinessAbnormality crmBusinessAbnormality) {
        return service.updateById(crmBusinessAbnormality);
    }

    /**
     * 导入市场监管-经营异常
     */
    @ApiOperation("市场监管-经营异常导入")
    @Log(title = "市场监管-经营异常", businessType = BusinessType.IMPORT)
    @PostMapping("/importData")
    public AjaxResult importData(MultipartFile file)
    {
        try {
            List<CrmBusinessAbnormality> crmBusinessAbnormalityAll = service.list();
            List<CrmBusinessAbnormality> list = ExcelUtils.readMultipartFile(file, CrmBusinessAbnormality.class,CrmBusinessAbnormality.class.getDeclaredFields().length - 2);
            if(crmBusinessAbnormalityAll != null && crmBusinessAbnormalityAll.size() > 0){
                //return AjaxResult.error("数据已存在，如需重新导入请清空数据");
            }
            if(list.size() > 0){
                service.saveBatch(list);
                return success("导入成功，共计："+list.size()+"条");
            }else{
                return AjaxResult.error("无数据");
            }
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导入数据失败");
        }
    }

    @ApiOperation("市场监管-经营异常导出")
    @Log(title = "市场监管-经营异常", businessType = BusinessType.EXPORT)
    @PostMapping("/exportData")
    public AjaxResult exportData(HttpServletResponse response, String conditionJson){
        try {
            List<CrmBusinessAbnormality> wrapperList = service.list(SearchUtil.parseWhereSql(conditionJson));
            ExcelUtils.export(response,"市场监管-经营异常",wrapperList,CrmBusinessAbnormality.class);
            return AjaxResult.success("导出数据成功");
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导出数据失败");
        }
    }

    @Log(title = "市场监管-经营异常", businessType = BusinessType.DELETE)
    @PostMapping("/delete")
    @ApiOperation(value = "删除市场监管-经营异常", notes = "删除市场监管-经营异常")
    public AjaxResult delete(@RequestBody List<String> ids)
    {
        return toAjax(service.removeByIds(ids));
    }

    @DeleteMapping("/deleteAll")
    @ApiOperation(value = "清除数据", notes = "清除数据")
    public AjaxResult deleteAll(){
        return service.deleteAll();
    }

    @PostMapping("/getUploadTemplate")
    @ApiOperation(value = "获取上传模板", notes = "获取上传模板")
    public void getUploadTemplate(HttpServletResponse response) throws IOException {
        DowntemplateUtil.downloadTemplate(response,"市场监管-经营异常模板");
    }
}

